"""Read in sww file, interpolate at specified locations and
    Cross section at specified T

"""
from os import sep
import Numeric
import project
from pyvolution.util import file_function
from create_buildings import porosity, WidtH
# from run_friction import fric
from pylab import *
from numerical_tools import norm, corr, err  




gauge_depth = Numeric.arrayrange(46, 1.5*WidtH, 25)
print len(gauge_depth),"gauge_depth length"
gauge_breadth = 100
gauge_locations = []

for GD in gauge_depth:
    gauge_location = [GD,gauge_breadth]
    gauge_locations.append(gauge_location)


swwfile_B = project.outputdir + sep  + 'Straight_offset_11.sww'

#Read model output
quantities = ['stage', 'elevation', 'xmomentum', 'ymomentum']

f_B = file_function(swwfile_B,
                  quantities = quantities,
                  interpolation_points = gauge_locations,
                  verbose = True,
                  use_cache = True)

Corr_OK=[]
fric_OK=[]
least_norm=[1]
norm_OK=[]
Friction = Numeric.arrayrange(1,80,1)
for fric in Friction:
    swwfile_F = project.outputdir + sep  + 'friction_n=' + repr(fric) + '_3135.sww'
    f_F = file_function(swwfile_F,
                      quantities = quantities,
                      interpolation_points = gauge_locations,
                      verbose = True,
                      use_cache = True)

    t=1000 # specifies times to look at cross sections
    
    stages_B = []
    stages_F = []
    for i, GL in enumerate(gauge_depth):

        # mines data from specified time values in sww file
        # Building file
        wB = f_B(t, point_id = i)[0]
        zB = f_B(t, point_id = i)[1]
        uhB = f_B(t, point_id = i)[2]
        vhB = f_B(t, point_id = i)[3]
        # Friction file
        wF = f_F(t, point_id = i)[0]        
        uhF = f_B(t, point_id = i)[2]
        vhF = f_B(t, point_id = i)[3]

        #m = sqrt(uh*uh + vh*vh)   #Absolute momentum
        velB = sqrt(uhB*uhB + vhB*vhB) / (wB + 1.e-30) #Absolute velocity
        velF = sqrt(uhF*uhF + vhF*vhF) / (wF + 1.e-30) #Absolute velocity                   
        stages_B.append(wB)
        stages_F.append(wF)
        
        
    Ar_B = Numeric.array(stages_B)
    Ar_F = Numeric.array(stages_F)
    diff = abs(Ar_B - Ar_F)
    norm_F = err(Ar_B, Ar_F, 2, relative = True)# 2nd norm (RMS) test
     
    print " "
    print norm_F, "norm N_F"
    print " "
    norm_OK.append(norm_F)

    if norm_F < least_norm:
        least_norm = norm_F
        fric_OK = fric
    else:
        print fric, " NOT OK" 

    
    
print " "
print "_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_"
print fric_OK, " <- This Manning's n is best fit from 2nd norm test"
print "_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_"
print least_norm, "2nd normal of Friction vs Buildings  "
print "_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_"

